'use strict';

let mongo = require("mongodb");
let co = require('co');
let thunkify = require('thunkify');
let BemZk = require('bem-zk');

let normalData = {
  mongoDbIP: '192.168.7.3',
  /* mongoDb host IP */
  mongoDbPort: 27017,
  /* mongoDb port */
  intervalTimer: 60
}; /* update arrange list timer, this should not need be a configure data. */

let dbOpen;
let dbName = '_BEMCLOUD';
let hasInit = 0;
let zkAPI;

function historyCriticalChange(jsonData) {
  return;
}

function historyNormalDataChange(jsonData) {

  if ((jsonData.mongoDbIP != undefined) && (jsonData.mongoDbIP != normalData.mongoDbIP)) {
    /* this happen, we need restart. */
    process.exit(0);
    return;
  }

  if ((jsonData.mongoDbPort != undefined) && (jsonData.mongoDbPort != normalData.mongoDbPort)) {
    /* this happen, we need restart. */
    process.exit(0);
    return;
  }

  return;
}

function* init() {

  let moduleName = "history";
  zkAPI = new BemZk();
  zkAPI.initZookeeper(moduleName, historyCriticalChange, historyNormalDataChange);

  let getData = yield zkAPI.getNormalZkData(moduleName, "mongoDbIP");
  if (getData != undefined) {
    normalData.mongoDbIP = getData;
  }

  getData = yield zkAPI.getNormalZkData(moduleName, "mongoDbPort");
  if (getData != undefined) {
    normalData.mongoDbPort = getData;
  }

  let server = new mongo.Server(normalData.mongoDbIP, parseInt(normalData.mongoDbPort), {
    auto_reconnect: true
  });
  let db = new mongo.Db(dbName, server, {
    safe: true
  });
  dbOpen = yield thunkify(db.open).call(db);

  return;
}



function *rechargeMoney(option) {

  if ((option == undefined) ||
    (option.userId == undefined) ||
    (option.chargeId == undefined) ||
    (option.from == undefined) ||
    (option.money == undefined)) {
    console.log("option wrong input.");
    return 1;
  }

  if (0 == hasInit) {
    yield init();
    hasInit = 1;
  }

  if ((option.from != "weixin") && (option.from != "zhifubao")) {
    console.log("option.from wrong input.");
    return 1;
  }

  if ((isNaN(option.money))||
      (option.money <= 0)) {
    console.log("option.money wrong input.");
    return 2;
  }

  let chargeData = {};
  chargeData.userId = option.userId;
  chargeData.chargeId = option.chargeId;
  chargeData.from = option.from;
  chargeData.money = parseInt(option.money);
  chargeData.time = new Date().getTime();
  chargeData.type = "recharge";

  let chargeHistoryCollection = dbOpen.collection("chargeHistory");

  let chargeResult = yield thunkify(chargeHistoryCollection.insert).call(chargeHistoryCollection, chargeData);

  if(1 === chargeResult.result.ok)
  {
    return 0;
  }
  else
  {
    console.log("insert to mongo failed.");
    return 4;
  }
}

exports.rechargeMoney = rechargeMoney;
